/**
 * 
 */
package jalview.ws.dbsources;

import java.util.Hashtable;

import com.stevesoft.pat.Regex;

import jalview.datamodel.AlignmentI;
import jalview.datamodel.DBRefEntry;
import jalview.io.FastaFile;
import jalview.ws.seqfetcher.DbSourceProxy;
import jalview.ws.seqfetcher.DbSourceProxyImpl;
/**
 * TODO: later PFAM is a complex datasource - it currently returns a seed alignment, but could optionally return a full alignment.
 * TODO: later PFAM is a complex datasource - it could return a tree in addition to an alignment
 * TODO: HP: Incorporate jalview.gui.SequenceFetcher retrieval code here.
 * @author JimP
 *
 */
public class Pfam extends DbSourceProxyImpl implements DbSourceProxy
{

  public Pfam()
  {
    super();
    
  }

  /* (non-Javadoc)
   * @see jalview.ws.DbSourceProxy#getAccessionSeparator()
   */
  public String getAccessionSeparator()
  {
    // TODO Auto-generated method stub
    return null;
  }

  /* (non-Javadoc)
   * @see jalview.ws.DbSourceProxy#getAccessionValidator()
   */
  public Regex getAccessionValidator()
  {
    // TODO Auto-generated method stub
    return null;
  }

  /* (non-Javadoc)
   * @see jalview.ws.DbSourceProxy#getDbSource()
   */
  public String getDbSource()
  {
    return jalview.datamodel.DBRefSource.PFAM;
  }

  /* (non-Javadoc)
   * @see jalview.ws.DbSourceProxy#getDbSourceProperties()
   */
  public Hashtable getDbSourceProperties()
  {
    // TODO Auto-generated method stub
    return null;
  }

  /* (non-Javadoc)
   * @see jalview.ws.DbSourceProxy#getDbVersion()
   */
  public String getDbVersion()
  {
    // TODO Auto-generated method stub
    return null;
  }
  public static String PFAMURL = "http://www.sanger.ac.uk/cgi-bin/Pfam/getalignment.pl?format=fal&acc=";
  /* (non-Javadoc)
   * @see jalview.ws.DbSourceProxy#getSequenceRecords(java.lang.String[])
   */
  public AlignmentI getSequenceRecords(String queries) throws Exception
  {
    // TODO: this is not a perfect implementation. We need to be able to add individual references to each sequence in each family alignment that's retrieved. 
    startQuery();
    results = new StringBuffer();
    // split queries into many little ones.
    results.append(new FastaFile(
                PFAMURL+queries.trim().toUpperCase(), "URL").print());
    stopQuery();
    AlignmentI rcds = parseResult(results.toString());
    for (int s=0,sNum=rcds.getHeight(); s<sNum;s++)
    {
      rcds.getSequenceAt(s).addDBRef(new DBRefEntry(getDbSource(), getDbVersion(), queries.trim().toUpperCase()));
    }
    return rcds;
  }

  /* (non-Javadoc)
   * @see jalview.ws.DbSourceProxy#isValidReference(java.lang.String)
   */
  public boolean isValidReference(String accession)
  {
    return accession.indexOf("PF")==0;
  }

  public String getTestQuery()
  {
    return "PF00535";
  }

  public String getDbName()
  {
    return getDbSource();
  }
}
